/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.lang.extend $Revision: 1.6 $

*/
dojo.provide('epages.lang.extend');

epages.lang._mixin = function(/*Object*/ obj, /*Object*/ props){
	// summary:
	//		Adds all properties and methods of props to obj. This addition is
	//		"prototype extension safe", so that instances of objects will not
	//		pass along prototype defaults.
	// returns: overwritten values
	var tobj = {};
	var old  = {};
	for(var x in props){
		// the "tobj" condition avoid copying properties in "props"
		// inherited from Object.prototype.  For example, if obj has a custom
		// toString() method, don't overwrite it with the toString() method
		// that props inherited from Object.protoype
		if((typeof tobj[x] == "undefined") || (tobj[x] != props[x])){
			old[x] = obj[x];
			obj[x] = props[x];

		}
	}
	// IE doesn't recognize custom toStrings in for..in
	if(dojo.render.html.ie
		&& (typeof(props["toString"]) == "function")
		&& (props["toString"] != obj["toString"])
		&& (props["toString"] != tobj["toString"]))
	{
		obj.toString = props.toString;
	}
	return old; // Object
}

epages.lang.mixin = function(/*Object*/obj, /*Object...*/props){
	// summary:	Adds all properties and methods of props to obj.
	// returns: overwritten values
	var sumold = {};
	for(var i=1, l=arguments.length; i<l; i++){
		var old = epages.lang._mixin(obj, arguments[i]);
		epages.lang._mixin(sumold, old);
	}
	return sumold; // Object
}
