Ext.data.JsonP.jQuery_ui_uiInput({"tagname":"class","name":"jQuery.ui.uiInput","autodetected":{},"files":[{"filename":"input.js","href":"input.html#jQuery-ui-uiInput"}],"extends":"jQuery.widget","uses":["ep","ep.dict","ep.ui.tooltip","jQuery.fn.class","jQuery.fn.form","jQuery.support.multipleUpload","jQuery.support.placeholder"],"since":"6.11.0","members":[{"name":"options","tagname":"cfg","owner":"jQuery.ui.uiInput","id":"cfg-options","meta":{}},{"name":"addClass","tagname":"method","owner":"jQuery.ui.uiInput","id":"method-addClass","meta":{}},{"name":"removeClass","tagname":"method","owner":"jQuery.ui.uiInput","id":"method-removeClass","meta":{}},{"name":"changeValue","tagname":"event","owner":"jQuery.ui.uiInput","id":"event-changeValue","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-jQuery.ui.uiInput","short_doc":"Advanced handling for input elements. ...","component":false,"superclasses":["jQuery.widget"],"subclasses":["jQuery.ui.uiValidate"],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>jQuery.widget<div class='subclass '><strong>jQuery.ui.uiInput</strong></div></div><h4>Subclasses</h4><div class='dependency'><a href='#!/api/jQuery.ui.uiValidate' rel='jQuery.ui.uiValidate' class='docClass'>jQuery.ui.uiValidate</a></div><h4>Uses</h4><div class='dependency'><a href='#!/api/ep' rel='ep' class='docClass'>ep</a></div><div class='dependency'><a href='#!/api/ep.dict' rel='ep.dict' class='docClass'>ep.dict</a></div><div class='dependency'>ep.ui.tooltip</div><div class='dependency'>jQuery.fn.class</div><div class='dependency'>jQuery.fn.form</div><div class='dependency'>jQuery.support.multipleUpload</div><div class='dependency'>jQuery.support.placeholder</div><h4>Files</h4><div class='dependency'><a href='source/input.html#jQuery-ui-uiInput' target='_blank'>input.js</a></div></pre><div class='doc-contents'><p>Advanced handling for input elements.</p>\n\n<p>The <code>.uiInput()</code> method add advanced handling to a input elements.</p>\n\n<h3>Examples</h3>\n\n<p>Apply .uiInput() to all input element and set autofocus to the first matched element.</p>\n\n<p>JavaScript:</p>\n\n<pre><code>ep(':input')\n    .first()\n        .uiInput({autofocus: true})\n    .end()\n    .not(':first')\n        .uiInput()\n    .end();\n</code></pre>\n        <p>Available since: <b>6.11.0</b></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-cfg'>Config options</h3><div class='subsection'><div id='cfg-options' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiInput'>jQuery.ui.uiInput</span><br/><a href='source/input.html#jQuery-ui-uiInput-cfg-options' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiInput-cfg-options' class='name expandable'>options</a> : Object<span class=\"signature\"></span></div><div class='description'><div class='short'>Option to pass to the widget. ...</div><div class='long'><p>Option to pass to the widget.</p>\n<p>Defaults to: <code>{autofocus: false, big: false}</code></p><ul><li><span class='pre'>placeholder</span> : String<div class='sub-desc'><p>Placeholder text.</p>\n</div></li><li><span class='pre'>info</span> : String<div class='sub-desc'><p>An info text show as tooltip if the element has focus.</p>\n</div></li><li><span class='pre'>autofocus</span> : Boolean<div class='sub-desc'><p>Indication whether the element gets focus on page load.</p>\n<p>Defaults to: <code>false</code></p></div></li><li><span class='pre'>big</span> : Boolean<div class='sub-desc'><p>Indication whether the element is displayed bigger than the normal one.</p>\n<p>Defaults to: <code>false</code></p></div></li><li><span class='pre'>orientation</span> : String<div class='sub-desc'><p>Decide in which direction tooltipps will be shown. Can be either <em>right</em>, <em>left</em>, <em>top</em> or <em>bottom</em></p>\n</div></li></ul></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addClass' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiInput'>jQuery.ui.uiInput</span><br/><a href='source/input.html#jQuery-ui-uiInput-method-addClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiInput-method-addClass' class='name expandable'>addClass</a>( <span class='pre'>className</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>The .uiInput() method wraps an element around the input, the addClass add classes to the wrap element. ...</div><div class='long'><p>The <code>.uiInput()</code> method wraps an element around the input, the addClass add classes to the wrap element.</p>\n        <p>Available since: <b>6.11.0</b></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>className</span> : String<div class='sub-desc'><p>One or more class names to be added to the class attribute of each matched element.</p>\n</div></li></ul></div></div></div><div id='method-removeClass' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiInput'>jQuery.ui.uiInput</span><br/><a href='source/input.html#jQuery-ui-uiInput-method-removeClass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiInput-method-removeClass' class='name expandable'>removeClass</a>( <span class='pre'>className</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>The .uiInput() method wraps an element around the input, the removeClass removes classes from the wrap element. ...</div><div class='long'><p>The <code>.uiInput()</code> method wraps an element around the input, the removeClass removes classes from the wrap element.</p>\n        <p>Available since: <b>6.11.0</b></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>className</span> : String<div class='sub-desc'><p>A class name to be removed from the class attribute of each matched element.</p>\n</div></li></ul></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-event'>Events</h3><div class='subsection'><div id='event-changeValue' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiInput'>jQuery.ui.uiInput</span><br/><a href='source/input.html#jQuery-ui-uiInput-event-changeValue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiInput-event-changeValue' class='name expandable'>changeValue</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>This event is triggered when the value is changed. ...</div><div class='long'><p>This event is triggered when the value is changed.</p>\n        <p>Available since: <b>6.11.0</b></p>\n</div></div></div></div></div></div></div>","meta":{}});