Ext.data.JsonP.jQuery_ui_uiMobileslides({"tagname":"class","name":"jQuery.ui.uiMobileslides","autodetected":{},"files":[{"filename":"mobileslides.js","href":"mobileslides.html#jQuery-ui-uiMobileslides"}],"extends":"jQuery.widget","uses":["ep.ui.core","ep.ui.slidebox","jQuery.event.special.touch","jQuery.tmpl","jQuery.ui.widget"],"since":"6.15.0","members":[{"name":"images","tagname":"cfg","owner":"jQuery.ui.uiMobileslides","id":"cfg-images","meta":{}},{"name":"close","tagname":"method","owner":"jQuery.ui.uiMobileslides","id":"method-close","meta":{}},{"name":"open","tagname":"method","owner":"jQuery.ui.uiMobileslides","id":"method-open","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-jQuery.ui.uiMobileslides","short_doc":"Create a slideshow on mobile devices for a given set of images. ...","component":false,"superclasses":["jQuery.widget"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>jQuery.widget<div class='subclass '><strong>jQuery.ui.uiMobileslides</strong></div></div><h4>Uses</h4><div class='dependency'>ep.ui.core</div><div class='dependency'>ep.ui.slidebox</div><div class='dependency'>jQuery.event.special.touch</div><div class='dependency'>jQuery.tmpl</div><div class='dependency'>jQuery.ui.widget</div><h4>Files</h4><div class='dependency'><a href='source/mobileslides.html#jQuery-ui-uiMobileslides' target='_blank'>mobileslides.js</a></div></pre><div class='doc-contents'><p>Create a slideshow on mobile devices for a given set of images.</p>\n\n<p>The <code>ep.uiMobileslides()</code> method creates a slideshow for a given set of images.</p>\n\n<p>This slideshow is displayed in an overlay on top of the mobile web site. A click on the applied element opens\nthe slideshow.\nThis are the major differences to <code>ep.uiSlides()</code>.</p>\n\n<h3>Examples</h3>\n\n<p>Create a simple slideshow.</p>\n\n<p>JavaScript:</p>\n\n<pre><code>ep('#slides01')\n  .uiMobileslides({\n    images  : '<a href=\"#!/api/jQuery.ui.uiMobileslides-cfg-images\" rel=\"jQuery.ui.uiMobileslides-cfg-images\" class=\"docClass\">images</a> img',\n  });\n</code></pre>\n\n<p>HTML:</p>\n\n<pre><code>&lt;ul id=\"images\" style=\"display:none;\"&gt;\n  &lt;li&gt;\n    &lt;img\n      alt=\"Bild 1\"\n      src=\"ep/ui/slidesTest_Image1.jpg\"\n      data-src-m=\"ep/ui/slidesTest_Image1.jpg\"\n      data-src-l=\"ep/ui/slidesTest_Image1.jpg\"\n    /&gt;\n  &lt;/li&gt;\n  &lt;li&gt;\n    &lt;img\n      alt=\"Bild 2\"\n      src=\"ep/ui/slidesTest_Image2.jpg\"\n      data-src-m=\"ep/ui/slidesTest_Image2.jpg\"\n      data-src-l=\"ep/ui/slidesTest_Image2.jpg\"\n    /&gt;\n  &lt;/li&gt;\n  &lt;li&gt;\n    &lt;img\n      alt=\"Bild 3\"\n      src=\"ep/ui/slidesTest_Image1.jpg\"\n      data-src-m=\"ep/ui/slidesTest_Image1.jpg\"\n      data-src-l=\"ep/ui/slidesTest_Image1.jpg\"\n    /&gt;\n  &lt;/li&gt;\n&lt;/ul&gt;\n&lt;div id=\"slides01\"\"&gt;Open slideshow&lt;/div&gt;\n</code></pre>\n        <p>Available since: <b>6.15.0</b></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-cfg'>Config options</h3><div class='subsection'><div id='cfg-images' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiMobileslides'>jQuery.ui.uiMobileslides</span><br/><a href='source/mobileslides.html#jQuery-ui-uiMobileslides-cfg-images' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiMobileslides-cfg-images' class='name expandable'>images</a> : Array,Element,String<span class=\"signature\"></span></div><div class='description'><div class='short'><p>A set of images which will be displayed.</p>\n</div><div class='long'><p>A set of images which will be displayed.</p>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-close' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiMobileslides'>jQuery.ui.uiMobileslides</span><br/><a href='source/mobileslides.html#jQuery-ui-uiMobileslides-method-close' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiMobileslides-method-close' class='name expandable'>close</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Close the slideshow. ...</div><div class='long'><p>Close the slideshow.</p>\n        <p>Available since: <b>6.15.0</b></p>\n</div></div></div><div id='method-open' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiMobileslides'>jQuery.ui.uiMobileslides</span><br/><a href='source/mobileslides.html#jQuery-ui-uiMobileslides-method-open' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiMobileslides-method-open' class='name expandable'>open</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Open the slideshow (overlay). ...</div><div class='long'><p>Open the slideshow (overlay).</p>\n        <p>Available since: <b>6.15.0</b></p>\n</div></div></div></div></div></div></div>","meta":{}});