Ext.data.JsonP.jQuery_ui_uiPrevieweditor({"tagname":"class","name":"jQuery.ui.uiPrevieweditor","autodetected":{},"files":[{"filename":"previeweditor.js","href":"previeweditor.html#jQuery-ui-uiPrevieweditor"}],"extends":"jQuery.widget","uses":["ep","ep.alert","jQuery.ckeditor.adapters.jquery","jQuery.ui.widget"],"since":"6.15.0","members":[{"name":"base","tagname":"cfg","owner":"jQuery.ui.uiPrevieweditor","id":"cfg-base","meta":{}},{"name":"height","tagname":"cfg","owner":"jQuery.ui.uiPrevieweditor","id":"cfg-height","meta":{}},{"name":"holder","tagname":"cfg","owner":"jQuery.ui.uiPrevieweditor","id":"cfg-holder","meta":{}},{"name":"name","tagname":"cfg","owner":"jQuery.ui.uiPrevieweditor","id":"cfg-name","meta":{}},{"name":"navbar","tagname":"cfg","owner":"jQuery.ui.uiPrevieweditor","id":"cfg-navbar","meta":{}},{"name":"pageBreak","tagname":"cfg","owner":"jQuery.ui.uiPrevieweditor","id":"cfg-pageBreak","meta":{}},{"name":"width","tagname":"cfg","owner":"jQuery.ui.uiPrevieweditor","id":"cfg-width","meta":{}},{"name":"toggleToolbar","tagname":"method","owner":"jQuery.ui.uiPrevieweditor","id":"method-toggleToolbar","meta":{"chainable":true}}],"alternateClassNames":[],"aliases":{},"id":"class-jQuery.ui.uiPrevieweditor","short_doc":"Creates an inline editor for the preview view. ...","component":false,"superclasses":["jQuery.widget"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>jQuery.widget<div class='subclass '><strong>jQuery.ui.uiPrevieweditor</strong></div></div><h4>Uses</h4><div class='dependency'><a href='#!/api/ep' rel='ep' class='docClass'>ep</a></div><div class='dependency'>ep.alert</div><div class='dependency'>jQuery.ckeditor.adapters.jquery</div><div class='dependency'>jQuery.ui.widget</div><h4>Files</h4><div class='dependency'><a href='source/previeweditor.html#jQuery-ui-uiPrevieweditor' target='_blank'>previeweditor.js</a></div></pre><div class='doc-contents'><p>Creates an inline editor for the preview view.</p>\n\n<p>The <code>ep.uiPrevieweditor</code> method creates an inline editor for the preview view. In addition it provides necessary methods to connect the external toolbar to the CKEditor plugins.</p>\n\n<h3>Examples</h3>\n\n<p>Create a preview editor.</p>\n\n<p>JavaScript:</p>\n\n<pre><code>ep('#editorID').uiPrevieweditor({\n  'name' : 'editorName',\n  'navbar' : 'Content',\n  'pageBreak': false,\n  'height': $('#baseId').height(),\n  'width': $('#baseId').width(),\n  'holder': $('#holderId'),\n  'base': $('#baseId')\n});\n</code></pre>\n\n<p>HTML:</p>\n\n<pre><code>&lt;div id=\"baseId\"&gt;Some Content&lt;/div&gt;\n&lt;div id=\"holderId\" style=\"clear:both; position:relative;display: none;\"&gt;\n  &lt;textarea style=\"visiblity:hidden;\" name=\"editorName\" id=\"editorID\"&gt;Some Content&lt;/textarea&gt;\n&lt;/div&gt;\n</code></pre>\n        <p>Available since: <b>6.15.0</b></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-cfg'>Config options</h3><div class='subsection'><div id='cfg-base' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiPrevieweditor'>jQuery.ui.uiPrevieweditor</span><br/><a href='source/previeweditor.html#jQuery-ui-uiPrevieweditor-cfg-base' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiPrevieweditor-cfg-base' class='name expandable'>base</a> : Object<span class=\"signature\"></span></div><div class='description'><div class='short'><p>jQuery object of the DOM element which contents the source html.</p>\n</div><div class='long'><p>jQuery object of the DOM element which contents the source html.</p>\n</div></div></div><div id='cfg-height' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiPrevieweditor'>jQuery.ui.uiPrevieweditor</span><br/><a href='source/previeweditor.html#jQuery-ui-uiPrevieweditor-cfg-height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiPrevieweditor-cfg-height' class='name expandable'>height</a> : Integer<span class=\"signature\"></span></div><div class='description'><div class='short'><p>Height for the editor.</p>\n</div><div class='long'><p>Height for the editor.</p>\n</div></div></div><div id='cfg-holder' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiPrevieweditor'>jQuery.ui.uiPrevieweditor</span><br/><a href='source/previeweditor.html#jQuery-ui-uiPrevieweditor-cfg-holder' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiPrevieweditor-cfg-holder' class='name expandable'>holder</a> : Object<span class=\"signature\"></span></div><div class='description'><div class='short'><p>jQuery object of the DOM element which holds the textarea/editor.</p>\n</div><div class='long'><p>jQuery object of the DOM element which holds the textarea/editor.</p>\n</div></div></div><div id='cfg-name' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiPrevieweditor'>jQuery.ui.uiPrevieweditor</span><br/><a href='source/previeweditor.html#jQuery-ui-uiPrevieweditor-cfg-name' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiPrevieweditor-cfg-name' class='name expandable'>name</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'><p>Name of the editor (corresponds to the name attribute of the textarea).</p>\n</div><div class='long'><p>Name of the editor (corresponds to the name attribute of the textarea).</p>\n</div></div></div><div id='cfg-navbar' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiPrevieweditor'>jQuery.ui.uiPrevieweditor</span><br/><a href='source/previeweditor.html#jQuery-ui-uiPrevieweditor-cfg-navbar' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiPrevieweditor-cfg-navbar' class='name expandable'>navbar</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'><p>Add class to the html element inside the iframe to set special CSS for preview inline mode.</p>\n</div><div class='long'><p>Add class to the html element inside the iframe to set special CSS for preview inline mode.</p>\n</div></div></div><div id='cfg-pageBreak' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiPrevieweditor'>jQuery.ui.uiPrevieweditor</span><br/><a href='source/previeweditor.html#jQuery-ui-uiPrevieweditor-cfg-pageBreak' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiPrevieweditor-cfg-pageBreak' class='name expandable'>pageBreak</a> : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Flag that indicates if the pagebreak icon is shown (e.g. ...</div><div class='long'><p>Flag that indicates if the pagebreak icon is shown (e.g. for blog posts).</p>\n</div></div></div><div id='cfg-width' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiPrevieweditor'>jQuery.ui.uiPrevieweditor</span><br/><a href='source/previeweditor.html#jQuery-ui-uiPrevieweditor-cfg-width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiPrevieweditor-cfg-width' class='name expandable'>width</a> : Integer<span class=\"signature\"></span></div><div class='description'><div class='short'><p>Width for the editor.</p>\n</div><div class='long'><p>Width for the editor.</p>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-toggleToolbar' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='jQuery.ui.uiPrevieweditor'>jQuery.ui.uiPrevieweditor</span><br/><a href='source/previeweditor.html#jQuery-ui-uiPrevieweditor-method-toggleToolbar' target='_blank' class='view-source'>view source</a></div><a href='#!/api/jQuery.ui.uiPrevieweditor-method-toggleToolbar' class='name expandable'>toggleToolbar</a>( <span class='pre'>blnShow</span> ) : <a href=\"#!/api/jQuery.ui.uiPrevieweditor\" rel=\"jQuery.ui.uiPrevieweditor\" class=\"docClass\">jQuery.ui.uiPrevieweditor</a><span class=\"signature\"><span class='chainable' >chainable</span></span></div><div class='description'><div class='short'>Handles settings for the current editor if the external toolbar is toggled. ...</div><div class='long'><p>Handles settings for the current editor if the external toolbar is toggled.</p>\n        <p>Available since: <b>6.15.0</b></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>blnShow</span> : Boolean<div class='sub-desc'><p>Specifies path and name of the file containing the new preview image.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/jQuery.ui.uiPrevieweditor\" rel=\"jQuery.ui.uiPrevieweditor\" class=\"docClass\">jQuery.ui.uiPrevieweditor</a></span><div class='sub-desc'><p>this</p>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});